@echo off
setlocal

set CURL=tools\curl.exe
set FILEVER=tools\filever.exe

rem *** Setup ***
cd /d "%~dp0"
set CONFIG=%~1
set TARGET=%~2

if "%CONFIG%"=="" set CONFIG=Debug

if not "%TARGET%"=="" (
	for /f "tokens=4" %%v in ('%FILEVER% /b /a /d %TARGET%') do (
		set VERSION=%%v
	)
)

if not "%VERSION%"=="" (
	set OUTDIR=%~dp0output\%CONFIG%\mmp-player-framework-html5-%VERSION%
) else (
	set OUTDIR=%~dp0output\%CONFIG%\mmp-player-framework-html5
)

if exist "%OUTDIR%" rmdir /s /q "%OUTDIR%"

rem *** Create working folder ***
xcopy /e "..\src" "%OUTDIR%\temp\"

rem *** Remove unnecessary files ***
del "%OUTDIR%\temp\js\LogWriterPlugin.js"
del "%OUTDIR%\temp\js\ConsoleLogWriterPlugin.js"
del "%OUTDIR%\temp\js\DocumentLogWriterPlugin.js"

rem *** Order necessary files ***
ren "%OUTDIR%\temp\css\playerframework.css" "01_playerframework.css"
ren "%OUTDIR%\temp\css\control-strip.css" "02_control-strip.css"
ren "%OUTDIR%\temp\js\PlayerFramework.js" "01_PlayerFramework.js" 
ren "%OUTDIR%\temp\js\Class.js" "02_Class.js"
ren "%OUTDIR%\temp\js\Object.js" "03_Object.js"
ren "%OUTDIR%\temp\js\Plugin.js" "04_Plugin.js"
ren "%OUTDIR%\temp\js\ModulePlugin.js" "05_ModulePlugin.js"
ren "%OUTDIR%\temp\js\MediaPlugin.js" "06_MediaPlugin.js"
ren "%OUTDIR%\temp\js\VideoMediaPlugin.js" "07_VideoMediaPlugin.js"
ren "%OUTDIR%\temp\js\ControlPlugin.js" "08_ControlPlugin.js"
ren "%OUTDIR%\temp\js\VideoElementMediaPluginBase.js" "09_VideoElementMediaPluginBase.js"
ren "%OUTDIR%\temp\js\SilverlightMediaPluginBase.js" "10_SilverlightMediaPluginBase.js"
ren "%OUTDIR%\temp\js\StaticContentMediaPlugin.js" "11_StaticContentMediaPlugin.js"
ren "%OUTDIR%\temp\js\PlaylistPlugin.js" "12_PlaylistPlugin.js"
ren "%OUTDIR%\temp\js\TrackPlugin.js" "13_TrackPlugin.js"
ren "%OUTDIR%\temp\js\TrackDataProviderPlugin.js" "14_TrackDataProviderPlugin.js"
ren "%OUTDIR%\temp\js\ChapterTrackPlugin.js" "15_ChapterTrackPlugin.js"
ren "%OUTDIR%\temp\js\TimelineTrackPlugin.js" "16_TimelineTrackPlugin.js"
ren "%OUTDIR%\temp\js\CaptionTrackPlugin.js" "17_CaptionTrackPlugin.js"
ren "%OUTDIR%\temp\js\ControlStripPlugin.js" "18_ControlStripPlugin.js"

rem *** Build concatenated debug files ***\
copy /b "%OUTDIR%\temp\css" "..\css\playerframework.debug.css"
copy /b "%OUTDIR%\temp\js" "..\js\playerframework.debug.js"

rem *** Build minified release files ***
if "%CONFIG%"=="Release" (
	"%CURL%" --form compressfile[]=@"..\css\playerframework.debug.css" --form type=CSS --form redirect=1 --location "http://refresh-sf.com/yui/" > "..\css\playerframework.min.css"
	"%CURL%" --data-urlencode js_code@"..\js\playerframework.debug.js" --data compilation_level=SIMPLE_OPTIMIZATIONS --data output_info=compiled_code --data output_format=text "http://closure-compiler.appspot.com/compile" > "..\js\playerframework.min.js"
) else (
	copy "..\css\playerframework.debug.css" "..\css\playerframework.min.css"
	copy "..\js\playerframework.debug.js" "..\js\playerframework.min.js"
)

rem *** Build playerframework folder ***
xcopy "..\build\build-player-framework.bat" "%OUTDIR%\build\"
xcopy "..\css\playerframework.*.css" "%OUTDIR%\css\"
xcopy "..\js\playerframework.*.js" "%OUTDIR%\js\"
xcopy /e "..\src" "%OUTDIR%\src\"
xcopy "..\README.txt" "%OUTDIR%\"

rem *** Clean up ***
rmdir /s /q "%OUTDIR%\temp\"

endlocal
pause